import { __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

let FormlyFieldCheckbox = class FormlyFieldCheckbox extends FieldType {
};
FormlyFieldCheckbox = __decorate([
    Component({
        selector: 'formly-field-ion-checkbox',
        template: ` <ion-checkbox [formControl]="formControl" [ionFormlyAttributes]="field"> </ion-checkbox> `,
        changeDetection: ChangeDetectionStrategy.OnPush
    })
], FormlyFieldCheckbox);

let FormlyCheckboxModule = class FormlyCheckboxModule {
};
FormlyCheckboxModule = __decorate([
    NgModule({
        declarations: [FormlyFieldCheckbox],
        imports: [
            CommonModule,
            ReactiveFormsModule,
            IonicModule,
            FormlyFormFieldModule,
            FormlyModule.forChild({
                types: [
                    {
                        name: 'checkbox',
                        component: FormlyFieldCheckbox,
                        wrappers: ['form-field'],
                    },
                    {
                        name: 'boolean',
                        extends: 'checkbox',
                    },
                ],
            }),
        ],
    })
], FormlyCheckboxModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyCheckboxModule, FormlyFieldCheckbox };
//# sourceMappingURL=ngx-formly-ionic-checkbox.js.map
