import { __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

let FormlyFieldDatetime = class FormlyFieldDatetime extends FieldType {
};
FormlyFieldDatetime = __decorate([
    Component({
        selector: 'formly-field-ion-datetime',
        template: `
    <ion-datetime
      [cancelText]="to.cancelText"
      [dayNames]="to.dayNames"
      [dayShortNames]="to.dayShortNames"
      [dayValues]="to.dayValues"
      [displayFormat]="to.displayFormat"
      [doneText]="to.doneText"
      [hourValues]="to.hourValues"
      [minuteValues]="to.minuteValues"
      [monthNames]="to.monthNames"
      [monthShortNames]="to.monthShortNames"
      [monthValues]="to.monthValues"
      [pickerFormat]="to.pickerFormat"
      [pickerOptions]="to.pickerOptions"
      [yearValues]="to.yearValues"
      [min]="to.min"
      [max]="to.max"
      [formControl]="formControl"
      [ionFormlyAttributes]="field"
    >
    </ion-datetime>
  `,
        changeDetection: ChangeDetectionStrategy.OnPush
    })
], FormlyFieldDatetime);

let FormlyDatetimeModule = class FormlyDatetimeModule {
};
FormlyDatetimeModule = __decorate([
    NgModule({
        declarations: [FormlyFieldDatetime],
        imports: [
            CommonModule,
            ReactiveFormsModule,
            IonicModule,
            FormlyFormFieldModule,
            FormlyModule.forChild({
                types: [
                    {
                        name: 'datetime',
                        component: FormlyFieldDatetime,
                        wrappers: ['form-field'],
                    },
                ],
            }),
        ],
    })
], FormlyDatetimeModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyDatetimeModule, FormlyFieldDatetime as ɵa };
//# sourceMappingURL=ngx-formly-ionic-datetime.js.map
