import { __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

let FormlyFieldSlider = class FormlyFieldSlider extends FieldType {
};
FormlyFieldSlider = __decorate([
    Component({
        selector: 'formly-field-ion-range',
        template: `
    <ion-range [min]="to.min" [max]="to.max" [formControl]="formControl" [ionFormlyAttributes]="field">
      <ion-label slot="start">{{ to.min }}</ion-label>
      <ion-label slot="end">{{ to.max }}</ion-label>
    </ion-range>
  `,
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [':host { display: inherit; }']
    })
], FormlyFieldSlider);

let FormlySliderModule = class FormlySliderModule {
};
FormlySliderModule = __decorate([
    NgModule({
        declarations: [FormlyFieldSlider],
        imports: [
            CommonModule,
            ReactiveFormsModule,
            IonicModule,
            FormlyFormFieldModule,
            FormlyModule.forChild({
                types: [
                    { name: 'slider', component: FormlyFieldSlider, wrappers: ['form-field'] },
                    { name: 'range', extends: 'slider' },
                ],
            }),
        ],
    })
], FormlySliderModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FormlySliderModule, FormlyFieldSlider as ɵa };
//# sourceMappingURL=ngx-formly-ionic-slider.js.map
