import { __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { IonicModule } from '@ionic/angular';
import { ReactiveFormsModule } from '@angular/forms';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

let FormlyFieldTextArea = class FormlyFieldTextArea extends FieldType {
};
FormlyFieldTextArea = __decorate([
    Component({
        selector: 'formly-field-ion-textarea',
        template: `
    <ion-textarea [formControl]="formControl" [ionFormlyAttributes]="field" [cols]="to.cols" [rows]="to.rows">
    </ion-textarea>
  `,
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [':host { display: inherit; }']
    })
], FormlyFieldTextArea);

let FormlyTextAreaModule = class FormlyTextAreaModule {
};
FormlyTextAreaModule = __decorate([
    NgModule({
        declarations: [FormlyFieldTextArea],
        imports: [
            CommonModule,
            ReactiveFormsModule,
            IonicModule,
            FormlyFormFieldModule,
            FormlyModule.forChild({
                types: [
                    {
                        name: 'textarea',
                        component: FormlyFieldTextArea,
                        wrappers: ['form-field'],
                    },
                ],
            }),
        ],
    })
], FormlyTextAreaModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyFieldTextArea, FormlyTextAreaModule };
//# sourceMappingURL=ngx-formly-ionic-textarea.js.map
