import { __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

let FormlyFieldToggle = class FormlyFieldToggle extends FieldType {
};
FormlyFieldToggle = __decorate([
    Component({
        selector: 'formly-field-ion-toggle',
        template: ` <ion-toggle [formControl]="formControl" [ionFormlyAttributes]="field"> </ion-toggle> `,
        changeDetection: ChangeDetectionStrategy.OnPush
    })
], FormlyFieldToggle);

let FormlyToggleModule = class FormlyToggleModule {
};
FormlyToggleModule = __decorate([
    NgModule({
        declarations: [FormlyFieldToggle],
        imports: [
            CommonModule,
            ReactiveFormsModule,
            IonicModule,
            FormlyFormFieldModule,
            FormlyModule.forChild({
                types: [
                    {
                        name: 'toggle',
                        component: FormlyFieldToggle,
                        wrappers: ['form-field'],
                    },
                ],
            }),
        ],
    })
], FormlyToggleModule);

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyToggleModule, FormlyFieldToggle as ɵa };
//# sourceMappingURL=ngx-formly-ionic-toggle.js.map
