import { __extends, __decorate, __metadata } from 'tslib';
import { Component, ChangeDetectionStrategy, Input, Directive, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldWrapper, ɵFormlyAttributes, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';

var FormlyWrapperFormField = /** @class */ (function (_super) {
    __extends(FormlyWrapperFormField, _super);
    function FormlyWrapperFormField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormlyWrapperFormField = __decorate([
        Component({
            selector: 'formly-wrapper-ion-form-field',
            template: "\n    <ion-item [lines]=\"to.itemLines\">\n      <ion-label [position]=\"to.labelPosition\">\n        {{ to.label }}\n        <span *ngIf=\"to.required && to.hideRequiredMarker !== true\">*</span>\n      </ion-label>\n      <ng-template #fieldComponent></ng-template>\n    </ion-item>\n    <ion-item lines=\"none\" *ngIf=\"showError\">\n      <ion-label>\n        <ion-text color=\"danger\">\n          <p>\n            <formly-validation-message [field]=\"field\"></formly-validation-message>\n          </p>\n        </ion-text>\n      </ion-label>\n    </ion-item>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush
        })
    ], FormlyWrapperFormField);
    return FormlyWrapperFormField;
}(FieldWrapper));

var IonFormlyAttributes = /** @class */ (function (_super) {
    __extends(IonFormlyAttributes, _super);
    function IonFormlyAttributes() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IonFormlyAttributes.prototype.focusElement = function (element, value) {
        if (!element.setFocus || !value) {
            return;
        }
        if (!element.getInputElement()) {
            setTimeout(function () { return element.setFocus(); }, 300);
        }
        else {
            element.setFocus();
        }
    };
    __decorate([
        Input('ionFormlyAttributes'),
        __metadata("design:type", Object)
    ], IonFormlyAttributes.prototype, "field", void 0);
    IonFormlyAttributes = __decorate([
        Directive({
            // tslint:disable-next-line
            selector: '[ionFormlyAttributes]',
            host: {
                '(ionFocus)': 'onFocus($event)',
                '(ionBlur)': 'onBlur($event)',
                '(ionChange)': 'onChange($event)',
            },
        })
    ], IonFormlyAttributes);
    return IonFormlyAttributes;
}(ɵFormlyAttributes));

var FormlyFormFieldModule = /** @class */ (function () {
    function FormlyFormFieldModule() {
    }
    FormlyFormFieldModule = __decorate([
        NgModule({
            declarations: [FormlyWrapperFormField, IonFormlyAttributes],
            exports: [IonFormlyAttributes],
            imports: [
                CommonModule,
                ReactiveFormsModule,
                IonicModule,
                FormlyModule.forChild({
                    wrappers: [
                        {
                            name: 'form-field',
                            component: FormlyWrapperFormField,
                        },
                    ],
                }),
            ],
        })
    ], FormlyFormFieldModule);
    return FormlyFormFieldModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyFormFieldModule, IonFormlyAttributes as ɵIonFormlyAttributes, FormlyWrapperFormField as ɵa };
//# sourceMappingURL=ngx-formly-ionic-form-field.js.map
