import { __extends, __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

var FormlyFieldInput = /** @class */ (function (_super) {
    __extends(FormlyFieldInput, _super);
    function FormlyFieldInput() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormlyFieldInput = __decorate([
        Component({
            selector: 'formly-field-ion-input',
            template: "\n    <ion-input\n      *ngIf=\"to.type !== 'number'; else numberTmp\"\n      [type]=\"to.type || 'text'\"\n      [formControl]=\"formControl\"\n      [ionFormlyAttributes]=\"field\"\n    ></ion-input>\n    <ng-template #numberTmp>\n      <ion-input type=\"number\" [formControl]=\"formControl\" [ionFormlyAttributes]=\"field\"></ion-input>\n    </ng-template>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            styles: [':host { display: inherit; }']
        })
    ], FormlyFieldInput);
    return FormlyFieldInput;
}(FieldType));

var FormlyInputModule = /** @class */ (function () {
    function FormlyInputModule() {
    }
    FormlyInputModule = __decorate([
        NgModule({
            declarations: [FormlyFieldInput],
            imports: [
                CommonModule,
                ReactiveFormsModule,
                IonicModule,
                FormlyFormFieldModule,
                FormlyModule.forChild({
                    types: [
                        {
                            name: 'input',
                            component: FormlyFieldInput,
                            wrappers: ['form-field'],
                        },
                        { name: 'string', extends: 'input' },
                        {
                            name: 'number',
                            extends: 'input',
                            defaultOptions: {
                                templateOptions: {
                                    type: 'number',
                                },
                            },
                        },
                        {
                            name: 'integer',
                            extends: 'input',
                            defaultOptions: {
                                templateOptions: {
                                    type: 'number',
                                },
                            },
                        },
                    ],
                }),
            ],
        })
    ], FormlyInputModule);
    return FormlyInputModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyFieldInput, FormlyInputModule };
//# sourceMappingURL=ngx-formly-ionic-input.js.map
