import { __extends, __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ReactiveFormsModule } from '@angular/forms';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { IonicModule } from '@ionic/angular';
import { FormlySelectModule as FormlySelectModule$1 } from '@ngx-formly/core/select';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

var FormlyFieldSelect = /** @class */ (function (_super) {
    __extends(FormlyFieldSelect, _super);
    function FormlyFieldSelect() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.defaultOptions = {
            templateOptions: {
                options: [],
                compareWith: function (o1, o2) {
                    return o1 === o2;
                },
            },
        };
        return _this;
    }
    FormlyFieldSelect = __decorate([
        Component({
            selector: 'formly-field-ion-select',
            template: "\n    <!-- ng-container used as a workaround for https://github.com/ionic-team/ionic/issues/19324 -->\n    <ng-container *ngIf=\"to.options | formlySelectOptions: field | async; let selectOptions\">\n      <ion-select\n        [formControl]=\"formControl\"\n        [compareWith]=\"to.compareWith\"\n        [ionFormlyAttributes]=\"field\"\n        [multiple]=\"to.multiple\"\n        [interface]=\"to.interface\"\n        [okText]=\"to.okText\"\n        [cancelText]=\"to.cancelText\"\n      >\n        <ion-select-option *ngFor=\"let option of selectOptions\" [value]=\"option.value\">\n          {{ option.label }}\n        </ion-select-option>\n      </ion-select>\n    </ng-container>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            styles: [':host { display: inherit; }']
        })
    ], FormlyFieldSelect);
    return FormlyFieldSelect;
}(FieldType));

var FormlySelectModule = /** @class */ (function () {
    function FormlySelectModule() {
    }
    FormlySelectModule = __decorate([
        NgModule({
            declarations: [FormlyFieldSelect],
            imports: [
                CommonModule,
                ReactiveFormsModule,
                IonicModule,
                FormlyFormFieldModule,
                FormlySelectModule$1,
                FormlyModule.forChild({
                    types: [
                        {
                            name: 'select',
                            component: FormlyFieldSelect,
                            wrappers: ['form-field'],
                        },
                        { name: 'enum', extends: 'select' },
                    ],
                }),
            ],
        })
    ], FormlySelectModule);
    return FormlySelectModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { FormlyFieldSelect, FormlySelectModule };
//# sourceMappingURL=ngx-formly-ionic-select.js.map
