import { __extends, __decorate } from 'tslib';
import { Component, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FieldType, FormlyModule } from '@ngx-formly/core';
import { ReactiveFormsModule } from '@angular/forms';
import { IonicModule } from '@ionic/angular';
import { FormlyFormFieldModule } from '@ngx-formly/ionic/form-field';

var FormlyFieldSlider = /** @class */ (function (_super) {
    __extends(FormlyFieldSlider, _super);
    function FormlyFieldSlider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormlyFieldSlider = __decorate([
        Component({
            selector: 'formly-field-ion-range',
            template: "\n    <ion-range [min]=\"to.min\" [max]=\"to.max\" [formControl]=\"formControl\" [ionFormlyAttributes]=\"field\">\n      <ion-label slot=\"start\">{{ to.min }}</ion-label>\n      <ion-label slot=\"end\">{{ to.max }}</ion-label>\n    </ion-range>\n  ",
            changeDetection: ChangeDetectionStrategy.OnPush,
            styles: [':host { display: inherit; }']
        })
    ], FormlyFieldSlider);
    return FormlyFieldSlider;
}(FieldType));

var FormlySliderModule = /** @class */ (function () {
    function FormlySliderModule() {
    }
    FormlySliderModule = __decorate([
        NgModule({
            declarations: [FormlyFieldSlider],
            imports: [
                CommonModule,
                ReactiveFormsModule,
                IonicModule,
                FormlyFormFieldModule,
                FormlyModule.forChild({
                    types: [
                        { name: 'slider', component: FormlyFieldSlider, wrappers: ['form-field'] },
                        { name: 'range', extends: 'slider' },
                    ],
                }),
            ],
        })
    ], FormlySliderModule);
    return FormlySliderModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { FormlySliderModule, FormlyFieldSlider as ɵa };
//# sourceMappingURL=ngx-formly-ionic-slider.js.map
